<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      size="small"
      :inline="true"
      v-show="showSearch"
      label-width="88px"
    >
      <el-form-item label="项目名称" prop="itemName">
        <el-input
          v-model="queryParams.itemName"
          placeholder="请输入项目名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button
          type="primary"
          icon="el-icon-search"
          size="mini"
          @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
          >重置</el-button
        >
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['app:inspectionItem:add']"
          >新增</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['app:inspectionItem:remove']"
          >删除</el-button
        >
      </el-col>
      <right-toolbar
        :showSearch.sync="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="inspectionItemList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <!-- <el-table-column label="ID" align="center" prop="id" width="80" /> -->
      <el-table-column
        label="项目名称"
        align="center"
        prop="itemName"
        width="160"
      />
      <el-table-column label="检查结果" align="center" prop="resultArr">
        <template slot-scope="scope">
          <block v-for="(item, i) in scope.row.resultArr" :key="i">
            <span v-if="i > 0">,</span><span>{{ item.name }}</span>
          </block>
        </template>
      </el-table-column>
      <el-table-column
        fixed="right"
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
        width="180"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-view"
            @click="handleView(scope.row)"
            >查看</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['app:inspectionItem:edit']"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['app:inspectionItem:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改检查项目对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="600px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" :disabled="isView" label-width="120px">
        <el-form-item label="项目名称" prop="itemName">
          <el-input v-model="form.itemName" placeholder="请输入项目名称" />
        </el-form-item>
        <el-form-item
          v-for="(item, i) in form.resultArr"
          :key="i"
          :label="'检查结果-' + (i + 1)"
          :prop="'resultArr.' + i + '.name'"
          :rules="[
            {
              required: true,
              message: '检查结果不能为空',
              trigger: 'blur',
            },
            {
              min: 1,
              max: 10,
              message: '检查结果输入超出最大长度限制（10位）',
              trigger: 'blur',
            },
          ]"
        >
          <el-input
            v-model="item.name"
            placeholder="请输入检查结果"
            class="result-input"
          />
          <el-button
            class="result-add"
            type="primary"
            v-if="i == form.resultArr.length - 1"
            @click="addResult"
            ><i class="el-icon-plus"></i
          ></el-button>
          <el-button
            class="result-del"
            type="danger"
            v-if="i > 0 || form.resultArr.length > 1"
            @click="removeResult(i)"
            ><i class="el-icon-minus"></i
          ></el-button>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer" v-if="!isView">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listInspectionItem,
  getInspectionItem,
  delInspectionItem,
  addInspectionItem,
  updateInspectionItem,
} from "@/api/app/inspectionItem";

export default {
  name: "InspectionItem",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 检查项目表格数据
      inspectionItemList: [],
      // 弹出层标题
      title: "",
      isView:false,
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        itemName: null,
        result: null,
      },
      // 表单参数
      form: {
        id: null,
        itemName: null,
        resultArr: [
          {
            name: "",
          },
        ],
        result: null,
      },
      // 表单校验
      rules: {
        itemName: [
          { required: true, message: "项目名称不能为空", trigger: "blur" },
          {
            min: 1,
            max: 10,
            message: "项目名称输入超出最大长度限制（10位）",
            trigger: "blur",
          },
        ],
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    addResult() {
      this.form.resultArr.push({
        name: "",
      });
      console.log(this.form);
    },
    removeResult(i) {
      this.form.resultArr.splice(i, 1);
      console.log(this.form);
    },
    /** 查询检查项目列表 */
    getList() {
      this.loading = true;
      listInspectionItem(this.queryParams).then((response) => {
        this.inspectionItemList = response.rows;
        this.inspectionItemList.map((item) => {
          item.resultArr = item.result
            ? JSON.parse(item.result)
            : [
                {
                  name: "",
                },
              ];
        });

        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        itemName: null,
        resultArr: [
          {
            name: "",
          },
        ],
        result: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.isView = false;
      this.title = "添加检查项目";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getInspectionItem(id).then((response) => {
        this.form = response.data;
        let resultArr = this.form.result
          ? JSON.parse(this.form.result)
          : [
              {
                name: "",
              },
            ];
        this.$set(this.form, "resultArr", resultArr);

        console.log(this.form);
        this.open = true;
        this.isView = false;
        this.title = "修改检查项目";
      });
    },
    /** 查看按钮操作 */
    handleView(row) {
      this.reset();
      const id = row.id || this.ids;
      getInspectionItem(id).then((response) => {
        this.form = response.data;
        let resultArr = this.form.result
          ? JSON.parse(this.form.result)
          : [
              {
                name: "",
              },
            ];
        this.$set(this.form, "resultArr", resultArr);

        this.open = true;
        this.isView = true;
        this.title = "查看检查项目";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.form.result = this.form.resultArr
        ? JSON.stringify(this.form.resultArr)
        : "[]";
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updateInspectionItem(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addInspectionItem(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm('是否确认删除检查项目编号为"' + ids + '"的数据项？')
        .then(function () {
          return delInspectionItem(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "app/inspectionItem/export",
        {
          ...this.queryParams,
        },
        `inspectionItem_${new Date().getTime()}.xlsx`
      );
    },
  },
};
</script>
<style scoped>
.result-input {
  width: 300px;
}
.result-add {
  margin-left: 10px;
}
.result-del {
  margin-left: 10px;
}
</style>
